// UrsOneShotTimerBase
//
// Autor: http://UllisRoboterSeite.de
// Doku:  http://bienonline.magix.net/public/esp8266-timing.html
// Created: 2016-05-04
//

#include <UrsOneShotBase.h>

void UrsOneShotBaseCallbackWrapper(void *pUrsOneShotBase)
{ UrsOneShotBase * p = (UrsOneShotBase *) pUrsOneShotBase;
  p->timerCallback();
  p->_isRunning = false;
}

UrsOneShotBase::UrsOneShotBase()
{ os_timer_setfn(&_osTimer, UrsOneShotBaseCallbackWrapper, this);
}

void UrsOneShotBase::start(uint32_t milliSeconds)
{ if (_isArmed)
    os_timer_disarm(&_osTimer);

  os_timer_arm(&_osTimer, milliSeconds, false);
  _isRunning = _isArmed = true;
}

void UrsOneShotBase::stop()
{ if (_isArmed)
  {  os_timer_disarm(&_osTimer);
    _isRunning = _isArmed = false;
  }
}